# TP 08 : Tri
# BCPST1B 2023-2024
# Lycée Hoche, Versailles
# L.-C. LEFÈVRE

# fichier à compléter intégrant tous les tests

#%% ne pas exécuter
# ou ne pas tenir compte de l'erreur

if __name__ == "__main__":
    raise RuntimeError("Exécuter les cellules")

#%% exercice 1

# classique ! à savoir faire sans aide !
def est_croissante(L):
    n = len(L)
    ...

# test
L = [2, 6, 7, 7, 9, 15]
print("L =", L)
print(est_croissante(L))
M = [1, 8, 3, 2, 4, 25]
print("M =", M)
print(est_croissante(M))

#%% exercice 2

def maximum(L):
    n = len(L)
    assert n != 0, "le maximum d'une liste vide n'est pas défini"
    # au départ le maximum supposé ne peut être que...
    M = ...
    # parcourir la liste
    for i in range(...):
        # L[i] est-il le nouveau maximum ?
        ...
    return M

# test
L = [10, 1, 5, 6, 7, 5]
print("L =", L)
print(maximum(L))
M = [1, 1, 5, 6, 9, 5]
print("M =", M)
print(maximum(M))
N = [1, 8, 6, 8, 8, 12]
print("N =", N)
print(maximum(N))

#%% exercice 3

def ordonne(L, i, j):
    # s'ils ne sont pas dans le bon ordre...
    if ... :
        # échanger les éléments d'indice i et j
        ...
    return L

# test
L = [1, 8, 3, 2, 1, 25]
print("L =", L)
i = 1
j = 2
print("i =", i, "j =", j)
ordonne(L, i, j)
print(L)
i = 3
j = 5
print("i =", i, "j =", j)
ordonne(L, i, j)
print(L)
i = 4
j = 2
print("i =", i, "j =", j)
ordonne(L, i, j)
print(L)
# pouvez-vous continuer pour trier complètement la liste ?
# ...

#%% exercice 4

def tri_bulle(L):
    n = len(L)
    # répéter le bon nombre de fois
    for i in range(...):
        # parcourir la liste et ordonner, si nécessaire, deux éléments consécutifs
        for j in range(...):
            ...
    return L

# test
L = [6, 9, 7, 6, 8, 3, 2, 5]
print("L = ", L)
print(tri_bulle(L))
M = [9, 2, 7, 1, 3, 1, 2, 1]
print("M =", M)
print(tri_bulle(M))
N = [1, 8, 5, 8, 6, 4, 1, 7]
print("N =", N)
print(tri_bulle(N))

#%% bonus
# rajouter des print dans la boucle (créer une fonction tri_bulle_print) et observer le résultat
L = [5, 4, 3, 2, 1]
tri_bulle_print(L)

#%% exercice 5

def tri_selection(L):
    n = len(L)
    # placer l'élément d'indice i, pour chaque i
    for i in range(...):
        # chercher l'indice du minimum de la liste à partir de l'indice i, inclus
        imin = i
        for j in range(...):
            ...
        # échanger les éléments d'indices i et imin
        ...
    return L

# test
L = [6, 9, 7, 6, 8, 3, 2, 5]
print("L = ", L)
print(tri_selection(L))
M = [9, 2, 7, 1, 3, 1, 2, 1]
print("M =", M)
print(tri_selection(M))
N = [1, 8, 5, 8, 6, 4, 1, 7]
print("N =", N)
print(tri_selection(N))
    
#%% exercice 6

def tri_insertion(L):
    n = len(L)
    # répéter : prendre l'élément d'indice i et l'insérer à sa place parmi les i premiers éléments
    for i in range(...):
        x = L[i]
        # décaler vers la droite les éléments d'indice de 0 à i-1 tant qu'ils sont plus grands que x
        j = ...
        while ... :
            ...
        # insérer x à l'indice j
        ...
    return L

# test
L = [6, 9, 7, 6, 8, 3, 2, 5]
print("L = ", L)
print(tri_insertion(L))
M = [9, 2, 7, 1, 3, 1, 2, 1]
print("M =", M)
print(tri_insertion(M))
N = [1, 8, 5, 8, 6, 4, 1, 7]
print("N =", N)
print(tri_insertion(N))

#%% exercice 7

# import ?
...

def tri_stupide(L):
    n = len(L)
    # tant que ce n'est pas fini
    while ... :
        # choisir des indices au hasard
        i = ...
        j = ...
        ordonne(L, i, j)
    return L

L = [6, 9, 7, 6, 8, 3, 2, 5]
print("L = ", L)
print(tri_stupide(L))
M = [9, 2, 7, 1, 3, 1, 2, 1]
print("M =", M)
print(tri_stupide(M))
N = [1, 8, 5, 8, 6, 4, 1, 7]
print("N =", N)
print(tri_stupide(N))

#%% bonus
# rajouter des print dans la boucle (créer une fonction tri_stupide_print) et observer le comportement avec des listes de plus en plus grandes
from random import randint
N = 30 # faire varier
# liste aléatoire de N nombres pris entre 1 et 100
L = [randint(1, 100) for _ in range(N)]
print("L =", L)
tri_stupide_print(L)

#%% exercice 8.1

# classique ! à savoir faire !
def compte(L, N):
    assert all(0 <= x and x <= N for x in L)
    ...

# test
L = [4, 2, 1, 5, 8, 9, 6, 5, 3, 7, 6, 3, 5, 4, 0, 2, 8, 3, 3, 4]
print(compte(L, 9))

#%% exercice 8.2

def tri_comptage(L):
    C = compte(L, N)
    M = [0] * len(L)
    # recontruire la liste :
    # i désigne un accumulateurs d'indices dans L
    # j est un indice dans C
    i = 0
    for j in range(N+1):
        # mettre un nombre consécutifs C[j] de termes égaux à j
        ...
    return M

# test
L = [4, 2, 1, 5, 8, 9, 6, 5, 3, 7, 6, 3, 5, 4, 0, 2, 8, 3, 3, 4]
print(tri_comptage(L))

#%% exercice 9

def mediane_1(L):
    ...

def mediane_2(L):
    ...

# test
L = [8, 14, 9, 10, 0, 9, 6, 8, 9, 6, 9, 2, 7, 12, 13, 6, 7, 10, 2, 11, 8, 14, 8, 11, 10, 8, 6, 14, 6, 8, 0, 8, 12, 0, 6, 8, 6, 4, 0, 8, 9, 8, 0, 6, 8, 8, 17, 13, 12, 8]
print(mediane_1(L))
print(mediane_2(L))
